#include "mmc.h"
#include "types.h"

#define LINESIZE 128

struct fat_filedata_st {
	u32 len;
	u32 startsect;
	u16 rootsect;
	u08 rootsectoffs;
	u08 entries; // LFN => entries > 1
	u08 name[LINESIZE];
};

#define NOSECTORSEARCH

#define FILEMODE_CLOSED 0
#define FILEMODE_READ 1
#define FILEMODE_WRITE 2

// functions
u08up fat_init();
void fat_count_files(void);
u08up fat_read_filedata(u08up nr);	// new file data in global struct
void fat_delete_file(void);
void fat_new_file(void);	// new file data in global struct
u08up fat_openfile(u08up mode, u08up nr);
u08up fat_closefile(void);
u08up fat_getnextsector(void);
