#include <LPC213x.H>                       /* LPC213x definitions  */
#include "types.h"

void spi_init(void) {
	// setup spi interface
	SSPCR0 = 0x4A07; // 400kHz SPI
	SSPCR1 = 0x02;
	SSPCPSR = 2;
};

u08up spi_io(u08up data) {
	SSPDR = data;
	while (SSPSR & 0x10); // While busy
	return SSPDR;
};

void spi_send_async(u08up data) {
	volatile u08up flush;
	SSPDR = data;
	while (!(SSPSR & 0x02)); // While Tx FIFO is full
	while (SSPSR & 4)	// While Rx FIFO not empty
		flush = SSPDR;
};

void spi_wait_completion(void) {
	volatile u08up flush;
	while (SSPSR & 0x10); // While busy
	while (SSPSR & 4)	// While Rx FIFO not empty
		flush = SSPDR;
}